<?php
/*
Plugin Name: Oddballauctions.com Sidebar Widget
Plugin URI: http://oddballauctions.com
Description: Displays latest posts from oddballauctions.com Optionally you can add your Ebay PID to earn extra revenue. We will use your PID 50% of the time.
Author: Nima Amini.
Author URI: http://www.oddballauctions.com/
Version: 1.0
*/

function widget_oddball_rss_init() {
	
	// Check for the required API functions
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
		return;


function widget_oddball_rss($args, $number = 1) {
	if ( file_exists(ABSPATH . WPINC . '/rss.php') )
		require_once(ABSPATH . WPINC . '/rss.php');
	else
		require_once(ABSPATH . WPINC . '/rss-functions.php');
	extract($args);
	$options = get_option('widget_oddball_rss');
	$num_items = (int) $options[$number]['items'];
	$num_pid = $options[$number]['pid'];
	$show_summary = $options[$number]['show_summary'];
	$show_power = $options[$number]['show_power'];
	if ( empty($num_items) || $num_items < 1 ) $num_items = 10;
	$url = $options[$number]['url']."?items=".$num_items;
	if ($num_pid!="") $url = $url."&pid=".$num_pid;
	if ( empty($url) )
		return;
	while ( strstr($url, 'http') != $url )
		$url = substr($url, 1);
	$rss = fetch_rss($url);
	$link = wp_specialchars(strip_tags($rss->channel['link']), 1);
	while ( strstr($link, 'http') != $link )
		$link = substr($link, 1);//print_r($rss->channel['description']);
	$desc = wp_specialchars(strip_tags(html_entity_decode($rss->channel['description'], ENT_QUOTES)), 1);
	$title = $options[$number]['title'];
	if ( empty($title) )
		$title = htmlentities(strip_tags($rss->channel['title']));
	if ( empty($title) )
		$title = $desc;
	if ( empty($title) )
		$title = __('Unknown Feed', 'widgets');
	$url = wp_specialchars(strip_tags($url), 1);
	if ( file_exists(dirname(__FILE__) . '/rss.png') )
		$icon = str_replace(ABSPATH, get_settings('siteurl').'/', dirname(__FILE__)) . '/rss.png';
	else
		$icon = get_settings('siteurl').'/wp-includes/images/rss.png';
	$title = "<a class='rsswidget' href='$url' title='Syndicate this content'><img width='14' height='14' src='$icon' alt='RSS' /></a> <a class='rsswidget' href='$link' title='$desc'>$title</a>";
?>
		<?php echo $before_widget; ?>
			<?php $title ? print($before_title . $title . $after_title) : null; ?>
			<ul>
<?php
	if ( is_array( $rss->items ) ) {
		$rss->items = array_slice($rss->items, 0, $num_items);
		foreach ($rss->items as $item ) {
			while ( strstr($item['link'], 'http') != $item['link'] )
				$item['link'] = substr($item['link'], 1);
			if ( $show_summary ) {
			//$link = wp_specialchars(strip_tags($item['link']), 1);
			$string2 = $item['content']['encoded'];
			$first=strpos($string2, '"http://')+1;
			$string3=substr($string2,$first);
			$first2=strpos($string3, '"');
			$link=substr($string3,0,$first2);
			}
			else {
			$string2 = $item['content']['encoded'];
			$first=strpos($string2, '"http://')+1;
			$string3=substr($string2,$first);
			$first2=strpos($string3, '"');
			$link=substr($string3,0,$first2);}
			$title = wp_specialchars(strip_tags($item['title']), 1);
			if ( empty($title) )
				$title = __('Untitled');
			if ( $show_summary ) {
				$desc = '';
				$summary = '<div class="rssSummary">' . $item['content']['encoded'] . '</div>';
			} else {
				$desc = str_replace(array("\n", "\r"), ' ', wp_specialchars(strip_tags(html_entity_decode($item['description'], ENT_QUOTES)), 1));
				$summary = '';
			}
			if ($title != 'Instructions' && $title != 'Restricted')
			{
				echo "<li><a class='rsswidget' href='$link' title='$desc' target='_blank'>$title</a>$summary</li>";
			}
		}
	} else {
		echo __('<li>An error has occured; the feed is probably down. Try again later.</li>', 'widgets');
	}
?>
			</ul>
			<?php if ($show_power==1) {?><p style="font-size:xx-small" align="right">powered by <a href="http://www.oddballauctions.com/" target="_blank">oddballauctions</a></p><?php }?> 
		<?php echo $after_widget; ?>
<?php
}

function widget_oddball_rss_control() {
	$number = 1;	
	$options = $newoptions = get_option('widget_oddball_rss');
	if ( $_POST["oddball-rss-submit-$number"] ) {
		$newoptions[$number]['items'] = (int) $_POST["oddball-rss-items-$number"];
		$newoptions[$number]['pid'] = $_POST["oddball-rss-pid-$number"];
		$newoptions[$number]['show_power'] = $_POST["oddball-rss-show_power-$number"];
		$newoptions[$number]['show_summary'] = $_POST["oddball-rss-show_summary-$number"];
		$newoptions[$number]['url'] = strip_tags(stripslashes($_POST["oddball-rss-url-$number"]));
		$newoptions[$number]['title'] = trim(strip_tags(stripslashes($_POST["oddball-rss-title-$number"])));
	}
	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('widget_oddball_rss', $options);
	}
	$url = htmlspecialchars($options[$number]['url'], ENT_QUOTES);
	$items = (int) $options[$number]['items'];
	$pid = $options[$number]['pid'];
	$show_summary = $options[$number]['show_summary'];
	$show_power = $options[$number]['show_power'];
	$title = htmlspecialchars($options[$number]['title'], ENT_QUOTES);
	if ( empty($items) || $items < 1 ) $items = 10;
	if ( empty($show_summary) ) $show_summary = 0;
?>
			
			<input type="hidden" id="oddball-rss-url-<?php echo "$number"; ?>" name="oddball-rss-url-<?php echo "$number"; ?>" value="http://www.oddballauctions.com/wordpress/rss2.php" />
			<p style="text-align:center;"><?php _e('Give the feed a title (optional):', 'widgets'); ?></p>
			<input style="width: 400px;" id="oddball-rss-title-<?php echo "$number"; ?>" name="oddball-rss-title-<?php echo "$number"; ?>" type="text" value="<?php echo $title; ?>" />
			<p style="text-align:center;"><?php _e('Ebay PID (Optional):', 'widgets'); ?></p>
			<input style="width: 400px;" id="oddball-rss-pid-<?php echo "$pid"; ?>" name="oddball-rss-pid-<?php echo "$number"; ?>" type="text" value="<?php echo $pid; ?>" />
			<p style="text-align:center; line-height: 30px;"><?php _e('How many items would you like to display?', 'widgets'); ?> <select id="oddball-rss-items-<?php echo $number; ?>" name="oddball-rss-items-<?php echo $number; ?>"><?php for ( $i = 1; $i <= 10; ++$i ) echo "<option value='$i' ".($items==$i ? "selected='selected'" : '').">$i</option>"; ?></select></p>
			<p style="text-align:center; line-height: 30px;"><?php _e('Show summary below titles?', 'widgets'); ?> <select id="oddball-rss-show_summary-<?php echo $number; ?>" name="oddball-rss-show_summary-<?php echo $number; ?>"><?php for ( $i = 0; $i <= 1; ++$i ) echo "<option value='$i' ".($show_summary==$i ? "selected='selected'" : '').">".($i==1 ? "Yes" : 'No')."</option>"; ?></select></p>
			<p style="text-align:center; line-height: 30px;"><?php _e('Show powered by oddballauctions below results?', 'widgets'); ?> <select id="oddball-rss-show_power-<?php echo $number; ?>" name="oddball-rss-show_power-<?php echo $number; ?>"><?php for ( $i = 0; $i <= 1; ++$i ) echo "<option value='$i' ".($show_power==$i ? "selected='selected'" : '').">".($i==1 ? "Yes" : 'No')."</option>"; ?></select></p>
			<input type="hidden" id="oddball-rss-submit-<?php echo "$number"; ?>" name="oddball-rss-submit-<?php echo "$number"; ?>" value="1" />
<?php
}

	

	// Tell Dynamic Sidebar about our new widget and its control
	register_sidebar_widget(array('OddBallAuctions', 'widgets'), 'widget_oddball_rss');
	register_widget_control(array('OddBallAuctions', 'widgets'), 'widget_oddball_rss_control',410, 200,1);
	
}

// Delay plugin execution to ensure Dynamic Sidebar has a chance to load first
add_action('widgets_init', 'widget_oddball_rss_init');


?>
